/// <reference types="node" />
import { IPluginStorage, Logger, PluginOptions, Callback, IPackageStorage, Token, TokenFilter } from '@verdaccio/types';
import { Level } from './level-adapter';
import { PGConfig } from './config';
declare class PGDatabase implements IPluginStorage<PGConfig> {
    logger: Logger;
    config: PGConfig;
    locked: boolean;
    tokenDb: Level<Token>;
    private sql;
    private ready;
    private data;
    constructor(config: PGConfig, options: PluginOptions<PGConfig>);
    getSecret(): Promise<string>;
    setSecret(secret: string): Promise<string>;
    add: (arg1: string, callback: (err: NodeJS.ErrnoException) => void) => void;
    search(onPackage: Callback, onEnd: Callback): Promise<void>;
    remove: (arg1: string, callback: (err: NodeJS.ErrnoException) => void) => void;
    get: (callback: (err: NodeJS.ErrnoException, result: any) => void) => void;
    getPackageStorage(packageName: string): IPackageStorage;
    clean(): void;
    saveToken(token: Token): Promise<void>;
    deleteToken(user: string, tokenKey: string): Promise<void>;
    readTokens(filter: TokenFilter): Promise<Token[]>;
    private _fetchLocalPackages;
    private _sync;
    private _getLocalStoragePath;
    private _getTokenKey;
    private _compoundTokenKey;
}
export default PGDatabase;
